Bug 60900 - Error using implicit operator with Nullable
Summary: Error using implicit operator with Nullable
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: master
Hardware: PC Windows
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2017-11-28 20:27 UTC by Jonathan Chambers
Modified: 2017-12-22 14:46 UTC (History)
1 user (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Jonathan Chambers 2017-11-28 20:27:39 UTC
csc:
no error

mcs: 
Program.cs(8,21): error CS0266: Cannot implicitly convert type `Program.MyStruct?' to `int'. An explicit conversion exists (are you missing a cast?)
Compilation failed: 1 error(s), 0 warnings


Compile following code:

using System;

public class Program
{
    public static int Main(string[] args)
    {
        int A = new MyStruct();
        // comment following line out and everything compiles fine
        int B = new Nullable<MyStruct> ();
        return 0;
    }
    public struct MyStruct
    {
        public static implicit operator int(Nullable<MyStruct> s) { return 0; }
    }
}
Comment 1 Marek Safar 2017-12-22 14:46:14 UTC
Fixed in master